
%{
open Ast
%}

%start program

%type <Ast.exp> exp exp2 exp3 program
%type <Ast.typ> typ

%token LLParen LRParen LColon LDot
%token LBool LInt LArrow
%token LTrue LFalse LPlus LGt
%token LFn LRec LIf LThen LElse
%token LEof
%token <int> LConst
%token <string> LVar

%left LGt
%left LPlus
%right LArrow
%%

typ:
  LBool               { Bool }
| LInt                { Int }
| typ LArrow typ      { Arrow($1,$3) }
| LLParen typ LRParen { $2 }

exp:
  exp2 { $1 }
| exp2 LPlus exp { Plus($1,$3) }
| exp  LGt   exp { GreaterThan($1,$3) }

exp2:
  exp3 { $1 }
| exp2 exp3 { Apply($1,$2) }

exp3:
  LTrue  { True}
| LFalse { False }
| LConst { Const($1) }
| LVar   { Var($1) } 
| LLParen LIf exp LThen exp LElse exp LRParen { If($3,$5,$7) }
| LLParen LFn  LVar LColon typ LDot      exp LRParen { Fun($3,$5,$7) }
| LLParen LRec LVar LColon typ LVar LDot exp LRParen { Rec($3,$5,$6,$8) }
| LLParen exp LRParen { $2 }

program:
    exp LEof { $1 }
